# Hægtesse
A daemon to transfer call audio data between a modem and PulseAudio.

Hægtesse was written solely for the SIMCom SIM7100 modem but may be
useful for other modems.  The audio format is hard-coded to mono,
signed 16-bit little-endian PCM samples at 8 kHz.

Probably the best place for this functionality would be a PulseAudio
plugin which listens to ModemManager over D-Bus and configures itself
according to ModemManager call audio meta-data.  This ModemManager
functionality is still under development, however.

## License
Hægtesse is licensed under the GPLv3+.

## Dependencies

    sudo apt-get install libpulse-dev libglib2.0-dev

A development version of ModemManager is required in order to send
appropriate AT commands to the SIM7100 for enabling call audio.  Our
development tree is here:

    https://source.puri.sm/Librem5/ModemManager


## Building
We use the meson and thereby Ninja.  The quickest way to get going is
to do the following:

    meson ../haegtesse-build
    ninja -C ../haegtesse-build
    ninja -C ../haegtesse-build install


## Running
Hægtesse is usually run as a systemd user service.  To run it by hand,
the program takes no options so just run it with the program name:

  $ haegtesse

Hægtesse will then query udev to find and/or wait for an appropriate
TTY.
