/*
 * Copyright (C) 2018 Purism SPC
 *
 * This file is part of Hægtesse.
 *
 * Hægtesse is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * Hægtesse is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Hægtesse.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Bob Ham <bob.ham@puri.sm>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */

#ifndef HAEG_SAMPLE_BUFFER_H__
#define HAEG_SAMPLE_BUFFER_H__

#include <glib-object.h>

G_BEGIN_DECLS

#define HAEG_TYPE_SAMPLE_BUFFER (haeg_sample_buffer_get_type ())

G_DECLARE_FINAL_TYPE (HaegSampleBuffer, haeg_sample_buffer, HAEG, SAMPLE_BUFFER, GObject);

HaegSampleBuffer * haeg_sample_buffer_new  (gint              fd,
                                            gsize             sample_len);
gsize              haeg_sample_buffer_read (HaegSampleBuffer *buffer,
                                            gchar            *buf,
                                            gsize             buf_len,
                                            GError          **error);

G_END_DECLS

#endif /* HAEG_SAMPLE_BUFFER_H__ */
